<!DOCTYPE html>
<html>
<head>
  <meta http-equiv="content-type" content="text/html;charset=utf-8">
  <title>views.py</title>
  <link rel="stylesheet" href="../pycco.css">
</head>
<body>
<div id='container'>
  <div id="background"></div>
  <div class='section'>
    <div class='docs'><h1>views.py</h1></div>
  </div>
  <div class='clearall'>
  <div class='section' id='section-0'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-0'>#</a>
      </div>
      
    </div>
    <div class='code'>
      <div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">django.contrib.sitemaps.views</span> <span class="kn">import</span> <span class="n">index</span>
<span class="kn">from</span> <span class="nn">django.shortcuts</span> <span class="kn">import</span> <span class="n">render</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-1'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-1'>#</a>
      </div>
      <p>Imports</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="kn">from</span> <span class="nn">allauth.socialaccount.models</span> <span class="kn">import</span> <span class="n">SocialAccount</span>
<span class="kn">from</span> <span class="nn">django.http</span> <span class="kn">import</span> <span class="n">HttpResponse</span>
<span class="kn">from</span> <span class="nn">django.template</span> <span class="kn">import</span> <span class="n">loader</span>
<span class="kn">from</span> <span class="nn">django.contrib.auth.models</span> <span class="kn">import</span> <span class="n">Permission</span><span class="p">,</span> <span class="n">User</span><span class="p">,</span> <span class="n">Group</span>

<span class="kn">from</span> <span class="nn">Proyecto.forms</span> <span class="kn">import</span> <span class="n">guardarEstimacion</span>
<span class="kn">from</span> <span class="nn">Proyecto.models</span> <span class="kn">import</span> <span class="n">miembros</span><span class="p">,</span> <span class="n">Proyectos</span><span class="p">,</span> <span class="n">PlanningPoker</span><span class="p">,</span> <span class="n">Sprint</span><span class="p">,</span> <span class="n">userStory</span>
<span class="kn">from</span> <span class="nn">decimal</span> <span class="kn">import</span> <span class="n">Decimal</span><span class="p">,</span> <span class="n">ROUND_HALF_UP</span>
<span class="kn">from</span> <span class="nn">Proyecto.views</span> <span class="kn">import</span> <span class="n">registrarModificacionBase</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-2'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-2'>#</a>
      </div>
      <p>vistas para Ingreso y permisos de usuarios del sistema</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-3'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-3'>#</a>
      </div>
      <p>Definicion para elegir si mostrar la página principal o el login que llega al SSO</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-4'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-4'>#</a>
      </div>
      
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">inicio</span><span class="p">(</span><span class="n">request</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-5'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-5'>#</a>
      </div>
      <p>Verificar si el usuario tiene la sesion activa</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">if</span> <span class="n">request</span><span class="o">.</span><span class="n">user</span><span class="o">.</span><span class="n">is_authenticated</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-6'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-6'>#</a>
      </div>
      <p>Condicion que verifica si el usuario que ingresa al sistema no tiene un rol asignado</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>        <span class="k">if</span> <span class="ow">not</span> <span class="n">request</span><span class="o">.</span><span class="n">user</span><span class="o">.</span><span class="n">groups</span><span class="o">.</span><span class="n">all</span><span class="p">():</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-7'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-7'>#</a>
      </div>
      <p>Si ingresa por primera vez se le da el rlo de Nuevo Usuario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>            <span class="n">rol</span> <span class="o">=</span> <span class="n">Group</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">filter</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="s1">&#39;Nuevo Usuario&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">first</span><span class="p">()</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-8'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-8'>#</a>
      </div>
      <p>SI no existe el rol de nuevo usuario se crea</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>            <span class="k">if</span> <span class="ow">not</span> <span class="n">rol</span><span class="p">:</span>
                <span class="n">nuevoRol</span> <span class="o">=</span> <span class="n">Group</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="s1">&#39;Nuevo Usuario&#39;</span><span class="p">)</span>
                <span class="n">nuevoRol</span><span class="o">.</span><span class="n">save</span><span class="p">()</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-9'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-9'>#</a>
      </div>
      <p>Tambien se crea eñ rol de SUPERADMIN y se le asigna todos los permisos</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>                <span class="n">superAdmin</span> <span class="o">=</span> <span class="n">Group</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="s1">&#39;SUPERADMIN&#39;</span><span class="p">)</span>
                <span class="n">superAdmin</span><span class="o">.</span><span class="n">save</span><span class="p">()</span>
                <span class="n">superAdmin</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">Permission</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">codename</span><span class="o">=</span><span class="s1">&#39;change_permission&#39;</span><span class="p">))</span>
                <span class="n">superAdmin</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">Permission</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">codename</span><span class="o">=</span><span class="s1">&#39;add_proyectos&#39;</span><span class="p">))</span>
                <span class="n">superAdmin</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">Permission</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">codename</span><span class="o">=</span><span class="s1">&#39;view_proyectos&#39;</span><span class="p">))</span>
                <span class="n">superAdmin</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">Permission</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">codename</span><span class="o">=</span><span class="s1">&#39;add_group&#39;</span><span class="p">))</span>
                <span class="n">superAdmin</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">Permission</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">codename</span><span class="o">=</span><span class="s1">&#39;change_group&#39;</span><span class="p">))</span>
                <span class="n">superAdmin</span><span class="o">.</span><span class="n">user_set</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">user</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-10'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-10'>#</a>
      </div>
      <p>Se asigna el rol &lsquo;Nuevo Usuario&rsquo;</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>                <span class="n">rol</span><span class="o">.</span><span class="n">user_set</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">user</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-11'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-11'>#</a>
      </div>
      <p>Template de la pagina principal del proyecto</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>        <span class="n">template</span> <span class="o">=</span> <span class="n">loader</span><span class="o">.</span><span class="n">get_template</span><span class="p">(</span><span class="s1">&#39;index.html&#39;</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-12'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-12'>#</a>
      </div>
      <p>Si el usuario no tiene la sesion activa entonces mostrar el login</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">else</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-13'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-13'>#</a>
      </div>
      <p>Template de la pagina principal del login</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>        <span class="n">template</span> <span class="o">=</span> <span class="n">loader</span><span class="o">.</span><span class="n">get_template</span><span class="p">(</span><span class="s1">&#39;login.html&#39;</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-14'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-14'>#</a>
      </div>
      <p>Retornamos una respuesta mostrando la pagina html correspondiente</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">context</span> <span class="o">=</span> <span class="n">cartasMenuInicio</span><span class="p">(</span><span class="n">request</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">HttpResponse</span><span class="p">(</span><span class="n">template</span><span class="o">.</span><span class="n">render</span><span class="p">(</span><span class="n">context</span><span class="p">,</span> <span class="n">request</span><span class="p">))</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-15'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-15'>#</a>
      </div>
      
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">cartasMenuInicio</span><span class="p">(</span><span class="n">request</span><span class="p">):</span>
    <span class="k">if</span> <span class="n">request</span><span class="o">.</span><span class="n">method</span> <span class="o">==</span> <span class="s1">&#39;POST&#39;</span><span class="p">:</span>
        <span class="n">formGuardarEstimacion</span> <span class="o">=</span> <span class="n">guardarEstimacion</span><span class="p">(</span><span class="n">request</span><span class="o">.</span><span class="n">POST</span><span class="p">)</span>
        <span class="n">sprint</span> <span class="o">=</span> <span class="n">Sprint</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">filter</span><span class="p">(</span><span class="n">pk</span><span class="o">=</span><span class="n">formGuardarEstimacion</span><span class="p">[</span><span class="s1">&#39;idSprint&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">value</span><span class="p">())</span><span class="o">.</span><span class="n">first</span><span class="p">()</span>
        <span class="n">us</span> <span class="o">=</span> <span class="n">userStory</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">filter</span><span class="p">(</span><span class="n">pk</span><span class="o">=</span><span class="n">formGuardarEstimacion</span><span class="p">[</span><span class="s1">&#39;idUs&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">value</span><span class="p">())</span><span class="o">.</span><span class="n">first</span><span class="p">()</span>
        <span class="n">planning</span> <span class="o">=</span> <span class="n">PlanningPoker</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">filter</span><span class="p">(</span><span class="n">idUs</span><span class="o">=</span><span class="n">us</span><span class="p">,</span> <span class="n">idSprint</span><span class="o">=</span><span class="n">sprint</span><span class="p">)</span><span class="o">.</span><span class="n">first</span><span class="p">()</span>
        <span class="n">formGuardarEstimacion</span><span class="o">.</span><span class="n">instance</span> <span class="o">=</span> <span class="n">planning</span>




        <span class="k">if</span> <span class="n">formGuardarEstimacion</span><span class="o">.</span><span class="n">is_valid</span><span class="p">():</span>
            <span class="n">formGuardarEstimacion</span><span class="o">.</span><span class="n">save</span><span class="p">()</span>
            <span class="n">estimacionEncargado</span> <span class="o">=</span> <span class="n">planning</span><span class="o">.</span><span class="n">estimacionEncargado</span>
            <span class="n">estimacionScrumMaster</span> <span class="o">=</span> <span class="n">planning</span><span class="o">.</span><span class="n">estimacionSM</span>
            <span class="n">planning</span><span class="o">.</span><span class="n">estimacionFinal</span> <span class="o">=</span> <span class="n">Decimal</span><span class="p">((</span> <span class="n">estimacionEncargado</span> <span class="o">+</span> <span class="n">estimacionScrumMaster</span> <span class="p">)</span> <span class="o">/</span> <span class="mi">2</span> <span class="p">)</span><span class="o">.</span><span class="n">quantize</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">ROUND_HALF_UP</span><span class="p">)</span>
            <span class="n">us</span><span class="o">.</span><span class="n">estimacion</span> <span class="o">=</span> <span class="n">Decimal</span><span class="p">((</span> <span class="n">estimacionEncargado</span> <span class="o">+</span> <span class="n">estimacionScrumMaster</span> <span class="p">)</span> <span class="o">/</span> <span class="mi">2</span> <span class="p">)</span><span class="o">.</span><span class="n">quantize</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">ROUND_HALF_UP</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-16'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-16'>#</a>
      </div>
      <p>registro de modificacion</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>            <span class="n">registroModificacion</span> <span class="o">=</span> <span class="n">registrarModificacionBase</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="n">us</span><span class="o">.</span><span class="n">idProyecto</span><span class="o">.</span><span class="n">id</span><span class="p">)</span>
            <span class="n">registroModificacion</span><span class="o">.</span><span class="n">idUs</span> <span class="o">=</span> <span class="n">us</span>
            <span class="n">registroModificacion</span><span class="o">.</span><span class="n">detalle</span> <span class="o">=</span> <span class="s2">&quot;Estimacion miembro: </span><span class="si">%d</span><span class="s2"> horas Estimacion Final: </span><span class="si">%.1f</span><span class="s2"> horas&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">estimacionEncargado</span><span class="p">,</span> <span class="p">(</span><span class="n">estimacionScrumMaster</span><span class="o">+</span><span class="n">estimacionEncargado</span><span class="p">)</span><span class="o">/</span><span class="mi">2</span><span class="p">)</span>
            <span class="n">registroModificacion</span><span class="o">.</span><span class="n">save</span><span class="p">()</span>

            <span class="n">us</span><span class="o">.</span><span class="n">save</span><span class="p">()</span>
            <span class="n">planning</span><span class="o">.</span><span class="n">save</span><span class="p">()</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-17'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-17'>#</a>
      </div>
      <p>Estimaciones</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">PPoker</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">proyecto</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">formEstimacion</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">if</span> <span class="n">request</span><span class="o">.</span><span class="n">user</span><span class="o">.</span><span class="n">is_authenticated</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-18'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-18'>#</a>
      </div>
      <p>buscamos todos los proyectos donde esta el user</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>        <span class="n">miembro</span> <span class="o">=</span> <span class="n">miembros</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">all</span><span class="p">()</span><span class="o">.</span><span class="n">filter</span><span class="p">(</span><span class="n">idUser</span><span class="o">=</span><span class="n">request</span><span class="o">.</span><span class="n">user</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">miembro</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-19'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-19'>#</a>
      </div>
      <p>planning poker en un proyecto x</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>            <span class="n">pPMiembro</span> <span class="o">=</span> <span class="n">PlanningPoker</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">all</span><span class="p">()</span><span class="o">.</span><span class="n">filter</span><span class="p">(</span><span class="n">miembroEncargado</span><span class="o">=</span><span class="n">x</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-20'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-20'>#</a>
      </div>
      <p>si el planning poker existe</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>            <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">pPMiembro</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-21'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-21'>#</a>
      </div>
      <p>si aun no se ha cargado una estimacion</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>                <span class="k">if</span> <span class="n">i</span> <span class="ow">and</span> <span class="ow">not</span> <span class="n">i</span><span class="o">.</span><span class="n">estimacionEncargado</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-22'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-22'>#</a>
      </div>
      <p>agregar a la lista de proyectos</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>                    <span class="n">proyecto</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">x</span><span class="o">.</span><span class="n">idProyecto</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-23'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-23'>#</a>
      </div>
      <p>agregar a la lista de planning poker</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>                    <span class="n">PPoker</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">i</span><span class="p">)</span>
                    <span class="n">formEstimacion</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">guardarEstimacion</span><span class="p">(</span><span class="n">instance</span><span class="o">=</span><span class="n">i</span><span class="p">))</span>
    <span class="n">context</span> <span class="o">=</span> <span class="p">{</span>
        <span class="s1">&#39;PlanningPoker&#39;</span><span class="p">:</span> <span class="n">PPoker</span><span class="p">,</span>
        <span class="s1">&#39;proyectos&#39;</span><span class="p">:</span> <span class="n">proyecto</span><span class="p">,</span>
        <span class="s1">&#39;formEstimacion&#39;</span><span class="p">:</span> <span class="n">formEstimacion</span><span class="p">,</span>
    <span class="p">}</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-24'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-24'>#</a>
      </div>
      <p>Tarea
agregar aqui el codigo para las tareas</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">return</span> <span class="n">context</span><span class="p">;</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-25'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-25'>#</a>
      </div>
      <p>Definicion que despliega la pagina principal de la seccionde &lsquo;permisos&rsquo;</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">index</span><span class="p">(</span><span class="n">request</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-26'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-26'>#</a>
      </div>
      <p>lista de usuario del sistema autenticados por el sso</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">listaDeUsarios</span> <span class="o">=</span> <span class="n">SocialAccount</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">order_by</span><span class="p">(</span><span class="s1">&#39;id&#39;</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-27'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-27'>#</a>
      </div>
      <p>Obtener el template del menu principal de permisos</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">template</span> <span class="o">=</span> <span class="n">loader</span><span class="o">.</span><span class="n">get_template</span><span class="p">(</span><span class="s1">&#39;oauth_app/index.html&#39;</span><span class="p">)</span>
    <span class="n">context</span> <span class="o">=</span> <span class="p">{</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-28'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-28'>#</a>
      </div>
      <p>Definimos la lista de usuarios del sistema para el template</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>        <span class="s1">&#39;listaDeUsarios&#39;</span><span class="p">:</span> <span class="n">listaDeUsarios</span><span class="p">,</span>
    <span class="p">}</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-29'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-29'>#</a>
      </div>
      <p>Retornamos una respuesta mostrando la pagina html correspondiente</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">return</span> <span class="n">HttpResponse</span><span class="p">(</span><span class="n">template</span><span class="o">.</span><span class="n">render</span><span class="p">(</span><span class="n">context</span><span class="p">,</span> <span class="n">request</span><span class="p">))</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-30'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-30'>#</a>
      </div>
      <p>Definicion que despliega una pagina con la lista de roles</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">listaRol</span><span class="p">(</span><span class="n">request</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-31'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-31'>#</a>
      </div>
      <p>lista de roles del sistema</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">listaRol</span> <span class="o">=</span> <span class="n">Group</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">order_by</span><span class="p">(</span><span class="s1">&#39;id&#39;</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-32'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-32'>#</a>
      </div>
      <p>Obtener el template de la lista de roles</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">template</span> <span class="o">=</span> <span class="n">loader</span><span class="o">.</span><span class="n">get_template</span><span class="p">(</span><span class="s1">&#39;oauth_app/listarRol.html&#39;</span><span class="p">)</span>
    <span class="n">context</span> <span class="o">=</span> <span class="p">{</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-33'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-33'>#</a>
      </div>
      <p>Definimos la lista de roles del sistema para el template</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>        <span class="s1">&#39;listaRol&#39;</span><span class="p">:</span> <span class="n">listaRol</span><span class="p">,</span>
    <span class="p">}</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-34'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-34'>#</a>
      </div>
      <p>Retornamos una respuesta mostrando la pagina html correspondiente</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">return</span> <span class="n">HttpResponse</span><span class="p">(</span><span class="n">template</span><span class="o">.</span><span class="n">render</span><span class="p">(</span><span class="n">context</span><span class="p">,</span> <span class="n">request</span><span class="p">))</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-35'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-35'>#</a>
      </div>
      <p>Definicion que despliega una pagina para crear un nuevo rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">crearRol</span><span class="p">(</span><span class="n">request</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-36'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-36'>#</a>
      </div>
      <p>Obtener el template para crear roles</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">template</span> <span class="o">=</span> <span class="n">loader</span><span class="o">.</span><span class="n">get_template</span><span class="p">(</span><span class="s1">&#39;oauth_app/crearRol.html&#39;</span><span class="p">)</span>
    <span class="n">context</span> <span class="o">=</span> <span class="p">{</span>
    <span class="p">}</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-37'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-37'>#</a>
      </div>
      <p>Retornamos la pagina para crear roles</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">return</span> <span class="n">HttpResponse</span><span class="p">(</span><span class="n">template</span><span class="o">.</span><span class="n">render</span><span class="p">(</span><span class="n">context</span><span class="p">,</span> <span class="n">request</span><span class="p">))</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-38'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-38'>#</a>
      </div>
      <p>Definicion para eliminar un rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">eliminarRol</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="n">RolId</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-39'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-39'>#</a>
      </div>
      <p>Obtenemos un rol en base al id que se recibe como parametro</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">rol</span> <span class="o">=</span> <span class="n">Group</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">pk</span><span class="o">=</span><span class="n">RolId</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-40'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-40'>#</a>
      </div>
      <p>Se elimina el rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">rol</span><span class="o">.</span><span class="n">delete</span><span class="p">()</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-41'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-41'>#</a>
      </div>
      <p>Se llama al def listaRol que despliega la lisra de roles</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">return</span> <span class="n">listaRol</span><span class="p">(</span><span class="n">request</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-42'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-42'>#</a>
      </div>
      <p>Definicion que despliega una pagina para modifica un rol existente</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">modificarRol</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="n">RolId</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-43'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-43'>#</a>
      </div>
      <p>Obtenemos un rol en base al id que se recibe como parametro</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">rol</span> <span class="o">=</span> <span class="n">Group</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">pk</span><span class="o">=</span><span class="n">RolId</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-44'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-44'>#</a>
      </div>
      <p>Obtenemos la lista de permisos del rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">permisos</span> <span class="o">=</span> <span class="n">rol</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">all</span><span class="p">()</span><span class="o">.</span><span class="n">values_list</span><span class="p">(</span><span class="s1">&#39;codename&#39;</span><span class="p">,</span> <span class="n">flat</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-45'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-45'>#</a>
      </div>
      <p>Obtener el template para modificar roles</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">template</span> <span class="o">=</span> <span class="n">loader</span><span class="o">.</span><span class="n">get_template</span><span class="p">(</span><span class="s1">&#39;oauth_app/editarRol.html&#39;</span><span class="p">)</span>
    <span class="n">context</span> <span class="o">=</span> <span class="p">{</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-46'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-46'>#</a>
      </div>
      <p>Definimos un objeto del tipo rol para el template</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>        <span class="s1">&#39;Rol&#39;</span><span class="p">:</span> <span class="n">rol</span><span class="p">,</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-47'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-47'>#</a>
      </div>
      <p>Definimos el id del rol el template</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>        <span class="s1">&#39;Rolid&#39;</span><span class="p">:</span> <span class="n">RolId</span><span class="p">,</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-48'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-48'>#</a>
      </div>
      <p>Definimos la lista de permisos del rol el template</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>        <span class="s1">&#39;Permisos&#39;</span><span class="p">:</span> <span class="n">permisos</span>
    <span class="p">}</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-49'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-49'>#</a>
      </div>
      <p>Retornamos la pagina para modificar roles</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">return</span> <span class="n">HttpResponse</span><span class="p">(</span><span class="n">template</span><span class="o">.</span><span class="n">render</span><span class="p">(</span><span class="n">context</span><span class="p">,</span> <span class="n">request</span><span class="p">))</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-50'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-50'>#</a>
      </div>
      <p>Definicion para guardar el nuevo rol creado</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">guardarNuevoRol</span><span class="p">(</span><span class="n">request</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-51'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-51'>#</a>
      </div>
      <p>Se obtiene el nombre del rol desde el formulario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">nombreRol</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">GET</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;nombre&#39;</span><span class="p">,</span> <span class="kc">False</span><span class="p">)</span>
    <span class="n">rol</span> <span class="o">=</span> <span class="n">Group</span><span class="p">(</span><span class="n">name</span><span class="o">=</span><span class="n">nombreRol</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-52'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-52'>#</a>
      </div>
      <p>SE crea un nuevo rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">rol</span><span class="o">.</span><span class="n">save</span><span class="p">()</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-53'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-53'>#</a>
      </div>
      <p>Obtenemos los permisos desde el formulario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">asignarPermisosForm1</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">GET</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;p1&#39;</span><span class="p">,</span> <span class="kc">False</span><span class="p">)</span>
    <span class="n">asignarPermisosForm2</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">GET</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;p2&#39;</span><span class="p">,</span> <span class="kc">False</span><span class="p">)</span>
    <span class="n">asignarPermisosForm3</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">GET</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;p3&#39;</span><span class="p">,</span> <span class="kc">False</span><span class="p">)</span>
    <span class="n">asignarPermisosForm4</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">GET</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;p4&#39;</span><span class="p">,</span> <span class="kc">False</span><span class="p">)</span>
    <span class="n">asignarPermisosForm5</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">GET</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;p5&#39;</span><span class="p">,</span> <span class="kc">False</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-54'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-54'>#</a>
      </div>
      <p>se obtienen los permisos del sistema</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">permiso1</span> <span class="o">=</span> <span class="n">Permission</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">codename</span><span class="o">=</span><span class="s1">&#39;change_permission&#39;</span><span class="p">)</span>
    <span class="n">permiso2</span> <span class="o">=</span> <span class="n">Permission</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">codename</span><span class="o">=</span><span class="s1">&#39;add_proyectos&#39;</span><span class="p">)</span>
    <span class="n">permiso3</span> <span class="o">=</span> <span class="n">Permission</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">codename</span><span class="o">=</span><span class="s1">&#39;view_proyectos&#39;</span><span class="p">)</span>
    <span class="n">permiso4</span> <span class="o">=</span> <span class="n">Permission</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">codename</span><span class="o">=</span><span class="s1">&#39;add_group&#39;</span><span class="p">)</span>
    <span class="n">permiso5</span> <span class="o">=</span> <span class="n">Permission</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">codename</span><span class="o">=</span><span class="s1">&#39;change_group&#39;</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-55'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-55'>#</a>
      </div>
      <p>Si se selecciono el permiso &lsquo;Gestionar Permisos&rsquo; en el formulario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">if</span> <span class="n">asignarPermisosForm1</span> <span class="o">==</span> <span class="s1">&#39;on&#39;</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-56'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-56'>#</a>
      </div>
      <p>Se agrega el permiso &lsquo;Gestionar Permisos&rsquo; al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>        <span class="n">rol</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">permiso1</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-57'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-57'>#</a>
      </div>
      <p>Si se selecciono el permiso &lsquo;Crear Proyecto&rsquo; en el formulario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">if</span> <span class="n">asignarPermisosForm2</span> <span class="o">==</span> <span class="s1">&#39;on&#39;</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-58'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-58'>#</a>
      </div>
      <p>Se agrega el permiso &lsquo;Crear Proyecto&rsquo; al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>        <span class="n">rol</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">permiso2</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-59'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-59'>#</a>
      </div>
      <p>Si se selecciono el permiso &lsquo;Ver Todos los Proyectos&rsquo; en el formulario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">if</span> <span class="n">asignarPermisosForm3</span> <span class="o">==</span> <span class="s1">&#39;on&#39;</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-60'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-60'>#</a>
      </div>
      <p>Se agrega el permiso &lsquo;Ver Todos los Proyectos&rsquo; al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>        <span class="n">rol</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">permiso3</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-61'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-61'>#</a>
      </div>
      <p>Si se selecciono el permiso &lsquo;Crear Roles del Sistema&rsquo; en el formulario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">if</span> <span class="n">asignarPermisosForm4</span> <span class="o">==</span> <span class="s1">&#39;on&#39;</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-62'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-62'>#</a>
      </div>
      <p>Se agrega el permiso &lsquo;Crear Roles del Sistema &lsquo; al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>        <span class="n">rol</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">permiso4</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-63'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-63'>#</a>
      </div>
      <p>Si se selecciono el permiso &lsquo;Modificar Roles del Sistema&rsquo; en el formulario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">if</span> <span class="n">asignarPermisosForm5</span> <span class="o">==</span> <span class="s1">&#39;on&#39;</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-64'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-64'>#</a>
      </div>
      <p>Se agrega el permiso &lsquo;Modificar Roles del Sistema&rsquo; al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>        <span class="n">rol</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">permiso5</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-65'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-65'>#</a>
      </div>
      <p>Se llama al def index que despliega la lista de usuarios</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">return</span> <span class="n">index</span><span class="p">(</span><span class="n">request</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-66'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-66'>#</a>
      </div>
      <p>Definicion para guardar las modificaciones del rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">guardarModificacionRol</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="n">RolId</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-67'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-67'>#</a>
      </div>
      <p>Obtenemos un rol en base al id que se recibe como parametro</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">rol</span> <span class="o">=</span> <span class="n">Group</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">pk</span><span class="o">=</span><span class="n">RolId</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-68'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-68'>#</a>
      </div>
      <p>Obtenemos la lista de permisos del rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">permisos</span> <span class="o">=</span> <span class="n">rol</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">all</span><span class="p">()</span><span class="o">.</span><span class="n">values_list</span><span class="p">(</span><span class="s1">&#39;codename&#39;</span><span class="p">,</span> <span class="n">flat</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-69'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-69'>#</a>
      </div>
      <p>Obtenemos los permisos desde el formulario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">asignarPermisosForm1</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">GET</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;p1&#39;</span><span class="p">,</span> <span class="kc">False</span><span class="p">)</span>
    <span class="n">asignarPermisosForm2</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">GET</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;p2&#39;</span><span class="p">,</span> <span class="kc">False</span><span class="p">)</span>
    <span class="n">asignarPermisosForm3</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">GET</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;p3&#39;</span><span class="p">,</span> <span class="kc">False</span><span class="p">)</span>
    <span class="n">asignarPermisosForm4</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">GET</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;p4&#39;</span><span class="p">,</span> <span class="kc">False</span><span class="p">)</span>
    <span class="n">asignarPermisosForm5</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">GET</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;p5&#39;</span><span class="p">,</span> <span class="kc">False</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-70'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-70'>#</a>
      </div>
      <p>se obtienen los permisos del sistema</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">permiso1</span> <span class="o">=</span> <span class="n">Permission</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">codename</span><span class="o">=</span><span class="s1">&#39;change_permission&#39;</span><span class="p">)</span>
    <span class="n">permiso2</span> <span class="o">=</span> <span class="n">Permission</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">codename</span><span class="o">=</span><span class="s1">&#39;add_proyectos&#39;</span><span class="p">)</span>
    <span class="n">permiso3</span> <span class="o">=</span> <span class="n">Permission</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">codename</span><span class="o">=</span><span class="s1">&#39;view_proyectos&#39;</span><span class="p">)</span>
    <span class="n">permiso4</span> <span class="o">=</span> <span class="n">Permission</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">codename</span><span class="o">=</span><span class="s1">&#39;add_group&#39;</span><span class="p">)</span>
    <span class="n">permiso5</span> <span class="o">=</span> <span class="n">Permission</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">codename</span><span class="o">=</span><span class="s1">&#39;change_group&#39;</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-71'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-71'>#</a>
      </div>
      <p>Verificamos si se selecciono el permiso &lsquo;Gestionar Permisos&rsquo; en el formulario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">if</span> <span class="n">asignarPermisosForm1</span> <span class="o">==</span> <span class="s1">&#39;on&#39;</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-72'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-72'>#</a>
      </div>
      <p>verificamos si el permiso no esta asociado al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>        <span class="k">if</span> <span class="ow">not</span> <span class="s1">&#39;change_permission&#39;</span> <span class="ow">in</span> <span class="n">permisos</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-73'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-73'>#</a>
      </div>
      <p>Se agrega el permiso al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>            <span class="n">rol</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">permiso1</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">if</span> <span class="s1">&#39;change_permission&#39;</span> <span class="ow">in</span> <span class="n">permisos</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-74'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-74'>#</a>
      </div>
      <p>Se elimina el permiso al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>            <span class="n">rol</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">permiso1</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-75'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-75'>#</a>
      </div>
      <p>Verificamos si se selecciono el permiso &lsquo;Crear Proyecto&rsquo; en el formulario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">if</span> <span class="n">asignarPermisosForm2</span> <span class="o">==</span> <span class="s1">&#39;on&#39;</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-76'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-76'>#</a>
      </div>
      <p>verificamos si el permiso no esta asociado al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>        <span class="k">if</span> <span class="ow">not</span> <span class="s1">&#39;add_proyectos&#39;</span> <span class="ow">in</span> <span class="n">permisos</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-77'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-77'>#</a>
      </div>
      <p>Se agrega el permiso al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>            <span class="n">rol</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">permiso2</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">if</span> <span class="s1">&#39;add_proyectos&#39;</span> <span class="ow">in</span> <span class="n">permisos</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-78'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-78'>#</a>
      </div>
      <p>Se elimina el permiso al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>            <span class="n">rol</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">permiso2</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-79'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-79'>#</a>
      </div>
      <p>Verificamos si se selecciono el permiso &lsquo;Ver Todos los Proyectos&rsquo; en el formulario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">if</span> <span class="n">asignarPermisosForm3</span> <span class="o">==</span> <span class="s1">&#39;on&#39;</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-80'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-80'>#</a>
      </div>
      <p>verificamos si el permiso no esta asociado al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>        <span class="k">if</span> <span class="ow">not</span> <span class="s1">&#39;view_proyectos&#39;</span> <span class="ow">in</span> <span class="n">permisos</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-81'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-81'>#</a>
      </div>
      <p>Se agrega el permiso al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>            <span class="n">rol</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">permiso3</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">if</span> <span class="s1">&#39;view_proyectos&#39;</span> <span class="ow">in</span> <span class="n">permisos</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-82'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-82'>#</a>
      </div>
      <p>Se elimina el permiso al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>            <span class="n">rol</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">permiso3</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-83'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-83'>#</a>
      </div>
      <p>Verificamos si se selecciono el permiso &lsquo;Crear Roles del Sistema&rsquo; en el formulario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">if</span> <span class="n">asignarPermisosForm4</span> <span class="o">==</span> <span class="s1">&#39;on&#39;</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-84'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-84'>#</a>
      </div>
      <p>verificamos si el permiso no esta asociado al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>        <span class="k">if</span> <span class="ow">not</span> <span class="s1">&#39;add_group&#39;</span> <span class="ow">in</span> <span class="n">permisos</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-85'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-85'>#</a>
      </div>
      <p>Se agrega el permiso al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>            <span class="n">rol</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">permiso4</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">if</span> <span class="s1">&#39;add_group&#39;</span> <span class="ow">in</span> <span class="n">permisos</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-86'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-86'>#</a>
      </div>
      <p>Se elimina el permiso al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>            <span class="n">rol</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">permiso4</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-87'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-87'>#</a>
      </div>
      <p>Verificamos si se selecciono el permiso &lsquo;Modificar Roles del Sistema&rsquo; en el formulario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">if</span> <span class="n">asignarPermisosForm5</span> <span class="o">==</span> <span class="s1">&#39;on&#39;</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-88'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-88'>#</a>
      </div>
      <p>verificamos si el permiso no esta asociado al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>        <span class="k">if</span> <span class="ow">not</span> <span class="s1">&#39;change_group&#39;</span> <span class="ow">in</span> <span class="n">permisos</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-89'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-89'>#</a>
      </div>
      <p>Se agrega el permiso al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>            <span class="n">rol</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">permiso5</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">if</span> <span class="s1">&#39;change_group&#39;</span> <span class="ow">in</span> <span class="n">permisos</span><span class="p">:</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-90'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-90'>#</a>
      </div>
      <p>Se elimina el permiso al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>            <span class="n">rol</span><span class="o">.</span><span class="n">permissions</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">permiso5</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-91'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-91'>#</a>
      </div>
      <p>Se retorna al template con la lista de roles</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">return</span> <span class="n">listaRol</span><span class="p">(</span><span class="n">request</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-92'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-92'>#</a>
      </div>
      <p>Definicion para obtener el template con el formulario para cambiar el rol del usuario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">datosUsuario</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="n">UsuarioId</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-93'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-93'>#</a>
      </div>
      <p>obtenemos los datos del usuario obtenidos anteriormente por el sso</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">SA</span> <span class="o">=</span> <span class="n">SocialAccount</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">pk</span><span class="o">=</span><span class="n">UsuarioId</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-94'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-94'>#</a>
      </div>
      <p>obtenemos los datos del usuario con el id que se obtiene como parametro</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">user</span> <span class="o">=</span> <span class="n">User</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">email__icontains</span><span class="o">=</span><span class="n">SA</span><span class="o">.</span><span class="n">extra_data</span><span class="p">[</span><span class="s1">&#39;email&#39;</span><span class="p">])</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-95'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-95'>#</a>
      </div>
      <p>obtenemos los datos del rol del usuario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">userRol</span> <span class="o">=</span> <span class="n">Group</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">filter</span><span class="p">(</span><span class="n">user</span><span class="o">=</span><span class="n">user</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-96'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-96'>#</a>
      </div>
      <p>obtenemos una lista con los roles del sistema</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">listaRol</span> <span class="o">=</span> <span class="n">Group</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">order_by</span><span class="p">(</span><span class="s1">&#39;id&#39;</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-97'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-97'>#</a>
      </div>
      <p>Obtener el template para modificar rol del usuario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">template</span> <span class="o">=</span> <span class="n">loader</span><span class="o">.</span><span class="n">get_template</span><span class="p">(</span><span class="s1">&#39;oauth_app/form.html&#39;</span><span class="p">)</span>
    <span class="n">context</span> <span class="o">=</span> <span class="p">{</span>
        <span class="s1">&#39;Usuario&#39;</span><span class="p">:</span> <span class="n">SA</span><span class="p">,</span>
        <span class="s1">&#39;Roles&#39;</span><span class="p">:</span> <span class="n">listaRol</span><span class="p">,</span>
        <span class="s1">&#39;Rol&#39;</span><span class="p">:</span> <span class="n">userRol</span><span class="p">,</span>
    <span class="p">}</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-98'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-98'>#</a>
      </div>
      <p>se retorna el formulario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">return</span> <span class="n">HttpResponse</span><span class="p">(</span><span class="n">template</span><span class="o">.</span><span class="n">render</span><span class="p">(</span><span class="n">context</span><span class="p">,</span> <span class="n">request</span><span class="p">))</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-99'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-99'>#</a>
      </div>
      <p>Definicion para guardar los datos del usuario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">datosForm</span><span class="p">(</span><span class="n">request</span><span class="p">,</span> <span class="n">UsuarioId</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-100'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-100'>#</a>
      </div>
      <p>obtenemos los datos del usuario obtenidos anteriormente por el sso</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">SA</span> <span class="o">=</span> <span class="n">SocialAccount</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">pk</span><span class="o">=</span><span class="n">UsuarioId</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-101'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-101'>#</a>
      </div>
      <p>obtenemos los datos del usuario con el id que se obtiene como parametro</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">user</span> <span class="o">=</span> <span class="n">User</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">email__icontains</span><span class="o">=</span><span class="n">SA</span><span class="o">.</span><span class="n">extra_data</span><span class="p">[</span><span class="s1">&#39;email&#39;</span><span class="p">])</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-102'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-102'>#</a>
      </div>
      <p>se obtiene el rol seleccionado</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">rolSeleccionado</span> <span class="o">=</span> <span class="n">request</span><span class="o">.</span><span class="n">GET</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;seleccionRol&#39;</span><span class="p">)</span>
    <span class="n">rol</span> <span class="o">=</span> <span class="n">Group</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">pk</span><span class="o">=</span><span class="n">rolSeleccionado</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-103'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-103'>#</a>
      </div>
      <p>eliminamos todos los roles del usuario</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">user</span><span class="o">.</span><span class="n">groups</span><span class="o">.</span><span class="n">clear</span><span class="p">()</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-104'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-104'>#</a>
      </div>
      <p>se agrega al usuario al rol</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">rol</span><span class="o">.</span><span class="n">user_set</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">user</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-105'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-105'>#</a>
      </div>
      <p>retornamos el menu principal de permisos</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="k">return</span> <span class="n">index</span><span class="p">(</span><span class="n">request</span><span class="p">)</span>

</pre></div>
    </div>
  </div>
  <div class='clearall'></div>
</div>
</body>
